//
//  ViewController.swift
//  array_inout
//
//  Created by yoshiyuki oshige on 2018/07/06.
//  Copyright © 2018年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {
    // 値を２倍にした新しい配列を作る（値渡し）
    func double(nums: [Int]) -> [Int] {
        var copied = nums  // 配列を複製する
        for i in 0..<nums.count {
            copied[i] *= 2  // 複製した配列を操作する
        }
        return copied
    }
    
    // 配列の値を２倍にする（参照渡し）
    func doubled(nums: inout [Int]) {
        for i in 0..<nums.count {
            nums[i] *= 2  // 引数で受け取った配列を操作する
        }
    }

    override func viewDidLoad() {
        super.viewDidLoad()
        // array1を２倍にしたarray1doubleを作る
        let array1 = [1, 2, 3]
        let array1double = double(nums: array1) // 値渡し
        print("array1", array1)
        print("array1double", array1double)
        // 元の配列の値を２倍にする
        var array2 = [10, 20, 30]
        doubled(nums: &array2)  // &を付けた参照渡し
        print("array2", array2)
    }
}

