//
//  ViewController.swift
//  class_init_convenience
//
//  Created by yoshiyuki oshige on 2018/07/14.
//  Copyright © 2018年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class Sector {
    // インスタンスプロパティ
    var r:Double   // 半径
    var rad:Double   // 中心角
    // 指定イニシャライザ
    init(r:Double = 1.0, radian:Double = .pi*2){
        self.r = r
        self.rad = radian
    }
    // コンビニエンスイニシャライザ
    convenience init(r:Double, degree:Double){
        // 角度をラジアンに変換
        let radian = degree*Double.pi/180.0
        // 指定イニシャライザで初期化
        self.init(r: r, radian: radian)
    }
    // インスタンスメソッド（扇形の面積を求める）
    func area() -> Double {
        let s = r*r*rad/2.0
        return s
    }
}

class ViewController: UIViewController {

    override func viewDidLoad() {
        super.viewDidLoad()
        // ２個の線形を作る
        let sector1 = Sector(r: 2, radian: .pi/4)
        let sector2 = Sector(r: 2, degree: 45)
        // 面積
        print(sector1.area())
        print(sector2.area())
    }
}

