//
//  ViewController.swift
//  class_init_init
//
//  Created by yoshiyuki oshige on 2018/10/09.
//  Copyright © 2018年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class MyClass {
    // インスタンスプロパティ
    let msg:String
    let name:String?
    
    // イニシャライザ1
    init (msg:String = "ハロー") {
        self.msg = msg
        self.name = nil
    }
    // イニシャライザ2
    init (msg:String = "ハロー", name:String) {
        self.msg = msg
        self.name = name
    }
    
    // インスタンスメソッド
    func hello(){
        var helloMsg:String
        if let user = name {
            // nameがnilでなければ連結する
            helloMsg = user + "さん。" + msg
        } else {
            helloMsg = msg
        }
        print(helloMsg)
    }
}

class ViewController: UIViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let myObj1 = MyClass(msg: "こんにちは")
        myObj1.hello()
        
        let myObj2 = MyClass(msg: "こんにちは", name:"桜子")
        myObj2.hello()
        
        let obj3 = MyClass()
        obj3.hello()
        
        let obj4 = MyClass(name:"月子")
        obj4.hello()
    }
}

