//
//  ViewController.swift
//  enum_associatedValue
//
//  Created by yoshiyuki oshige on 2018/10/09.
//  Copyright © 2018年 yoshiyuki oshige. All rights reserved.
//

import UIKit

class ViewController: UIViewController {

    // パターンの種類
    enum Pattern {
        case Monotone(_:PColor)
        case Border(color1:PColor, color2:PColor)
        case Dots(base:PColor, dot1:PColor, dot2:PColor)
    }
    
    // パターンで使える色
    enum PColor:String {
        case red = "赤"
        case green = "緑"
        case yellow = "黄"
        case white = "白"
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        // シャツのパターンを作る
        let shirt1 = Pattern.Monotone(.red)
        let shirt2 = Pattern.Border(color1: .white, color2: .red)
        let shirt3 = Pattern.Dots(base: .yellow, dot1: .white, dot2: .green)
        
        // 作った値をパターンで分類してみる
        let patternList = [shirt1, shirt2, shirt3]
        
        for thePattern in patternList {
            switch thePattern {
            case .Monotone(let c):
                print("\(c.rawValue)の無地")
            case .Border(let c1, let c2):
                print("\(c1.rawValue)と\(c2.rawValue)のボーダー")
            case let .Dots(base, dot1, dot2):
                let bColor = base.rawValue
                let dc1 = dot1.rawValue
                let dc2 = dot2.rawValue
                print("\(bColor)地に\(dc1)と\(dc2)のドット")
            }
        }
        
    }
    

}

