//
//  ViewController.swift
//  struct_protocol
//
//  Created by yoshiyuki oshige on 2018/07/14.
//  Copyright © 2018年 yoshiyuki oshige. All rights reserved.
//

import UIKit

// Monsterプロトコル
protocol Monster {
    var monsterName:String {get} // リードオンリー
    var hp:Int {get set}
    mutating func updateHP(pt:Int)
}

class ViewController: UIViewController {
    
    // Monsterプロトコルを採用しているBokemon構造体
    struct Bokemon: Monster {
        // プロパティ（プロトコル準拠）
        private(set) var monsterName:String  // リードオンリー
        var hp:Int
        // hpを変更するメソッド
        mutating func updateHP(pt:Int) {
            hp += pt
        }
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        var aMonster = Bokemon(monsterName: "スイフィー", hp: 200)
        aMonster.updateHP(pt: 30) // HPに30ポイント加算する
        print("\(aMonster.monsterName) HP:\(aMonster.hp)")
    }
}

